#!/bin/bash

# auxiliary information
date_of_inf1=('01-22') 
date_of_inf2=('02-19')

g++ aggravate_fsl.cc -o agg_fsl
g++ aggravate_fsl_encrypt.cc -o agg_fsl_encrypt

mkdir daydbs
mkdir day_fsl

# count frequency
for inf in ${date_of_inf1[@]}; do

	echo "Now count the origin fsl-2013-${inf}"
	./agg_fsl ${inf} > ./day_fsl/fsl_${inf}
	./build/bin/attack/distribution/count ./day_fsl/fsl_${inf} "daydbs/F_O_${inf}/" "daydbs/L_O_${inf}/" "daydbs/R_O_${inf}/"  

done

# count frequency
for inf in ${date_of_inf2[@]}; do

	echo "Now count the target fsl-2013-${inf}"
	./agg_fsl_encrypt ${inf} > ./day_fsl/fsl_${inf}_encrypt
	./build/bin/attack/distribution/count ./day_fsl/fsl_${inf}_encrypt "daydbs/F_T_${inf}/" "daydbs/L_T_${inf}/" "daydbs/R_T_${inf}/" 

done


# parameters
uc=('128') # u->top frequency 
rc=('16') # r-> radius
tc=('1.0') # t-> threshold
leakage_rate=0

rm -rf ./inference-db/
rm -rf ./ground-truth/

date_of_oinf='01-22' # auxiliary 
date_of_tinf=('02-19') # target


# distribution attack
for t in ${tc[@]}; do
	for sinf in ${date_of_tinf[@]}; do

		echo "=====Distribution-based Attack====="
		echo "Parameters: u: 128, r: 16, t: ${t} leakage_rate: ${leakage_rate}"
		echo "Source backup: $date_of_oinf"
		echo "Target backup: ${sinf}" 
		./build/bin/attack/distribution/attack 128 16 ${t} 30 ${leakage_rate} "daydbs/F_O_${date_of_oinf}/" "daydbs/L_O_${date_of_oinf}/" "daydbs/R_O_${date_of_oinf}/" "daydbs/F_T_${sinf}/" "daydbs/L_T_${sinf}/" "daydbs/R_T_${sinf}/"
		rm -rf ./inference-db/

	done
done

rm -rf ./inference-db/
rm -rf ./ground-truth/
