#include <iostream>
#include "leveldb/db.h"
#include <openssl/aes.h>

#define FP_SIZE 6

unsigned char aeskey[32] = {0};

void print_fp(char * a)
{
    int len = 0;
    for (len = 0; len < FP_SIZE; len++) {
        printf("%02x", (unsigned char)a[len]);
        if (len < FP_SIZE - 1) printf(":");
    }
    printf("\n");
}

void encrypt(FILE *fp , FILE *encrpt_fp);

/* encrypt  chunk hash */
void encrypt(FILE *fp , FILE *encrpt_fp)
{
    AES_KEY aes;
    if (AES_set_encrypt_key((unsigned char*)aeskey, 128, &aes) < 0)
    {
        printf("AES_set_encrypt_key failed\n");
        return;
    }
    
    AES_KEY daes;
    if (AES_set_decrypt_key((unsigned char*)aeskey, 128, &daes) < 0)
    {
        printf("AES_set_decrypt_key failed\n");
        return;
    }

    char read_buffer[256];
    char *item;

    // a new chunk
    char current_hash[16];
    char encrypt_hash[16];
    char tmp[16];
    char hash[FP_SIZE];


    // Read hash value from hash_file generated by `fs-hasher`
    while (fgets(read_buffer, 256, fp)) {

        if (strpbrk(read_buffer, "Chunk")) continue;
        if (strpbrk(read_buffer, "NEXTFILE"))  {
            fprintf(encrpt_fp,"NEXTFILE NEXTFILE\n");
            continue;
        }
        item = strtok(read_buffer, ":\t\n ");
        int idx = 0;
        while (item != NULL && idx < FP_SIZE) {
            // store hex value of hash into char array with base 16
            hash[idx] = strtol(item, NULL, 16);
            idx++;
            item = strtok(NULL, ":\t\n");
        }

        memset(current_hash, 0, 16);
        memcpy(current_hash, hash , FP_SIZE);
        memcpy(current_hash + FP_SIZE, hash, FP_SIZE);
        memcpy(current_hash + 2 * FP_SIZE, hash, 4);

        // aes_encrypt
        AES_encrypt((unsigned char *)current_hash,(unsigned char *)encrypt_hash,&aes);
        
        int len = 1;
        for (len = 1; len < FP_SIZE + 1; len++) {
            fprintf(encrpt_fp, "%02x", (unsigned char)encrypt_hash[len]);
            if (len < FP_SIZE ) fprintf(encrpt_fp, ":");
        }
        fprintf(encrpt_fp, "\n");
    }
}


int main(int argc, char *argv[]) {

    FILE *fp = fopen(argv[1], "r");
    if (fp == nullptr) {
        printf("[Error] Failed to open %s\n", argv[1]);
        return -1;
    }

    FILE *encrypt_fp = fopen(argv[2], "w");
    if (encrypt_fp == nullptr) {
        printf("[Error] Failed to open %s\n", argv[2]);
        return -1;
    }

    encrypt(fp,encrypt_fp);

    fclose(fp);
    fclose(encrypt_fp);

    return 0;
}

